/*
 * CalculoMCD
 * Calcula el MCD de dos números
 * Versión 1.0
 * www.ajpdsoft.com
 */

package ajpdsoftcalculomcd;

/**
 *
 * @author www.ajpdsoft.com
 */

public class CalculoMCD 
{
    private int numero1;
    private int numero2;
    private String mensajeResultado = "";
    
    //constructor de clase vacío, le pasaremos los valores por settters
    //para encapsularlos
    public CalculoMCD ()
    {
    }
    
    //setters
    public void setNumero1 (int numero)
    {
        this.numero1 = numero;
        //si el número es negativo cambiamos a cero y
        //establecemos la propiedad "mensajeResultado" a "Error"
        if (numero < 0)            
            mensajeResultado = "Error, los números no pueden ser negativos";
    }
    
    public void setNumero2 (int numero)
    {
        this.numero2 = numero;
        //si el número es negativo cambiamos a cero y
        //establecemos la propiedad "mensajeResultado" a "Error"
        if (numero < 0)
            mensajeResultado = "Error, los números no pueden ser negativos";
    }
    
    //resultado del cálculo del MCD
    public String getMensajeResultado() 
    {
        return mensajeResultado;
    }    
    
    //getters
    //encapsulamos la modificación de las variables numero1 y numero2
    //para comprobar que los valores son correctos entre 
    public int getNumero1 ()
    {
        return numero1;
    }
    
    public int getNumero2 ()
    {
        return numero2;
    }
    
    //método para obtener el MDC, encapsulamos para pasar como parámetro 
    //de numero1 el mayor de los dos
    public int obtenerMCD ()
    {
        if (numero1 < 0 || numero2 < 0) //si son números negativos no calcular
            return 0;
        else
            if (numero1 > numero2)
                return MCD(numero1, numero2);
            else
                return MCD(numero2, numero1);                  
     }
    
    //método para calcular el MCD
    private int MCD (int num1, int num2)
    {
        int resto;
        int numDiv1 = num1;
        int numDiv2 = num2;
        
        try
        {
            do
            {            
                resto = numDiv1 % numDiv2;
                numDiv1 = numDiv2;
                if (resto != 0)
                    numDiv2 = resto;            
            } while (resto != 0);
            
            mensajeResultado = "Cálculo correcto";
            return numDiv2;
        }
        catch (Exception e)
        {
            mensajeResultado = "Error en cálculo de MCD: " + e.getMessage();
            return 0;
        }
    }    
}
